﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.ComponentModel.Composition;

using NuMetaheuristics.Genotypes;
using NuMetaheuristics.Operators.Vector;
using NuMetaheuristics.Operators.Value;

namespace NuMetaheuristics.Contexts.Vector.Boolean
{
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    [Export(typeof(IContext<BooleanVectorGenotype>))]
    public class MaxOnes : BooleanVectorContext
    {
        public MaxOnes()
            : base()
        {
        }

        public MaxOnes(int length)
            : base(length)
        {
        }

        override public void Evaluate(ref BooleanVectorGenotype genome)
        {
            double total = 0.0;

            for (int i = 0; i < genome.Vector.Length; i++)
            {
                if (genome.Vector[i])
                {
                    total += 1.0;
                }
            }

            genome.Fitness = new FitnessBiggerIsBetter(total);
        }
    }
}
