﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.ComponentModel.Composition;

using NuMetaheuristics.Genotypes;
using NuMetaheuristics.Operators.Vector;
using NuMetaheuristics.Operators.Value;

namespace NuMetaheuristics.Contexts.Vector.Boolean
{
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    [Export(typeof(IContext<BooleanVectorGenotype>))]
    public class Trap : BooleanVectorContext
    {
        public Trap()
            : base()
        {
        }

        public Trap(int length)
            : base(length)
        {
        }

        override public void Evaluate(ref BooleanVectorGenotype genome)
        {
            int total = 0;

            for (int i = 0; i < genome.Vector.Length; i++)
            {
                if (false == genome.Vector[i])
                {
                    total++;
                }
            }

            //Here's the trap: when there are no zeros at all fitness is maximized.
            if (total == 0)
            {
                total = genome.Vector.Length + 1;
            }

            genome.Fitness = new FitnessBiggerIsBetter(total);
        }

    }
}
