﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.ComponentModel.Composition;

using NuMetaheuristics.Genotypes;
using NuMetaheuristics.Operators.Vector;
using NuMetaheuristics.Operators.Value;

namespace NuMetaheuristics.Contexts.Vector.Double
{
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    [Export(typeof(IContext<DoubleVectorGenotype>))]
    public class Rastrigin : DoubleVectorContext
    {
        public Rastrigin()
            : base()
        {
        }

        public Rastrigin(int length)
            : base(length, -5.12, 5.12)
        {
        }

        override public void Evaluate(ref DoubleVectorGenotype genome)
        {
            double total = 10 * genome.Vector.Length;

            foreach(double x in genome.Vector)
            {
                double a = x * x;
                double b = 10 * Math.Cos(2 * Math.PI * x);

                total += (a - b);
            }

            genome.Fitness = new FitnessSmallerIsBetter(total);
        }
    }
}
