﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.ComponentModel.Composition;

using NuMetaheuristics.Genotypes;
using NuMetaheuristics.Operators.Vector;
using NuMetaheuristics.Operators.Value;

namespace NuMetaheuristics.Contexts.Vector.Double
{
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    [Export(typeof(IContext<DoubleVectorGenotype>))]
    public class Step : DoubleVectorContext
    {
        public Step()
            : base()
        {
        }

        public Step(int length)
            : base(length, -5.12, 5.12)
        {
        }

        override public void Evaluate(ref DoubleVectorGenotype genome)
        {
            double total = 6 * genome.Vector.Length;

            foreach (double x in genome.Vector)
            {
                total += Math.Floor(x);
            }

            genome.Fitness = new FitnessSmallerIsBetter(total);
        }
    }
}
