﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.ComponentModel.Composition;

using NuMetaheuristics.Genotypes;
using NuMetaheuristics.Operators.Vector;
using NuMetaheuristics.Operators.Value;

namespace NuMetaheuristics.Contexts.Vector.Double
{
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    [Export(typeof(IContext<DoubleVectorGenotype>))]
    public class Sum : DoubleVectorContext
    {
        public Sum()
            : base()
        {
        }

        public Sum(int length)
            : base(length, 0.0, 1.0)
        {
        }

        override public void Evaluate(ref DoubleVectorGenotype genome)
        {
            double total = 0.0;

            foreach(double x in genome.Vector)
            {
                total += x;
            }

            genome.Fitness = new FitnessSmallerIsBetter(total);
        }
    }
}
