﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.ComponentModel.Composition;

using NuMetaheuristics;

namespace NuMetaheuristics.Operators.Value
{
    /// <summary>
    /// Add two values.
    /// </summary>
    [Export(typeof(IBinaryOperator<double>))]
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    public class DoubleValueAdder : IBinaryOperator<double>
    {
        public double Operate(double operandL, double operandR)
        {
            return operandL + operandR;
        }
    }

    /// <summary>
    /// Add two values.
    /// </summary>
    [Export(typeof(IBinaryOperator<int>))]
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    public class IntegerValueAdder : IBinaryOperator<int>
    {
        public int Operate(int operandL, int operandR)
        {
            return operandL + operandR;
        }
    }

    /// <summary>
    /// Subtract two values.
    /// </summary>
    [Export(typeof(IBinaryOperator<double>))]
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    public class DoubleValueSubtracter : IBinaryOperator<double>
    {
        public double Operate(double operandL, double operandR)
        {
            return operandL - operandR;
        }
    }

    /// <summary>
    /// Subtract two values.
    /// </summary>
    [Export(typeof(IBinaryOperator<int>))]
    [DataContract(Namespace = "http://numetaheuristics.codeplex.com/schemas")]
    public class IntegerValueSubtracter : IBinaryOperator<int>
    {
        public int Operate(int operandL, int operandR)
        {
            return operandL - operandR;
        }
    }
}
