﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xunit;

namespace NuMetaheuristics.UnitTests
{
    public class FitnessSmallerIsBetterTest
    {
        [Fact]
        public void DefaultCtorTest()
        {
            Fitness x = new FitnessSmallerIsBetter();
            Assert.True(x.Score == 0.0);
        }

        [Fact]
        public void ScoreCtorTest()
        {
            Fitness x = new FitnessSmallerIsBetter(2.0);
            Assert.True(x.Score == 2.0);
        }

        [Fact]
        public void CopyCtorTest()
        {
            Fitness x = new FitnessSmallerIsBetter(2.0);
            Fitness y = new FitnessSmallerIsBetter(x);
            Assert.True(x.Score == 2.0);
        }

        [Fact]
        public void EqualityTest()
        {
            Fitness x = new FitnessSmallerIsBetter(2.5);
            Fitness y = new FitnessSmallerIsBetter(2.5);
            Assert.True(x == y);
            Assert.False(x != y);
        }

        [Fact]
        public void InequalityTest()
        {
            Fitness x = new FitnessSmallerIsBetter(2.5);
            Fitness y = new FitnessSmallerIsBetter(2.48);
            Assert.False(x == y);
            Assert.True(x != y);
        }

        [Fact]
        public void CompareTest1()
        {
            Fitness x = new FitnessSmallerIsBetter(2.0);
            Fitness y = new FitnessSmallerIsBetter(2.5);
            Assert.True(x > y);
            Assert.True(y < x);
        }

        [Fact]
        public void CompareTest2()
        {
            Fitness x = new FitnessSmallerIsBetter(-2.0);
            Fitness y = new FitnessSmallerIsBetter(2.5);
            Assert.True(x > y);
            Assert.True(y < x);
        }
    }

    public class FitnessBiggerIsBetterTest
    {
        [Fact]
        public void DefaultCtorTest()
        {
            Fitness x = new FitnessBiggerIsBetter();
            Assert.True(x.Score == 0.0);
        }

        [Fact]
        public void ScoreCtorTest()
        {
            Fitness x = new FitnessBiggerIsBetter(2.0);
            Assert.True(x.Score == 2.0);
        }

        [Fact]
        public void CopyCtorTest()
        {
            Fitness x = new FitnessBiggerIsBetter(2.0);
            Fitness y = new FitnessBiggerIsBetter(x);
            Assert.True(x.Score == 2.0);
        }

        [Fact]
        public void EqualityTest()
        {
            Fitness x = new FitnessBiggerIsBetter(2.5);
            Fitness y = new FitnessBiggerIsBetter(2.5);
            Assert.True(x == y);
            Assert.False(x != y);
        }

        [Fact]
        public void InequalityTest()
        {
            Fitness x = new FitnessBiggerIsBetter(2.5);
            Fitness y = new FitnessBiggerIsBetter(2.48);
            Assert.False(x == y);
            Assert.True(x != y);
        }

        [Fact]
        public void CompareTest1()
        {
            Fitness x = new FitnessBiggerIsBetter(2.0);
            Fitness y = new FitnessBiggerIsBetter(2.5);
            Assert.True(x < y);
            Assert.True(y > x);
        }

        [Fact]
        public void CompareTest2()
        {
            Fitness x = new FitnessBiggerIsBetter(-2.0);
            Fitness y = new FitnessBiggerIsBetter(2.5);
            Assert.True(x < y);
            Assert.True(y > x);
        }
    }
}
