﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NuMetaheuristics;
using NuMetaheuristics.Operators.Value;

using Xunit;

namespace NuMetaheuristics.UnitTests.Operators.Value
{
    public class IntegerAbsValueTest
    {
        [Fact]
        public void BasicTest()
        {
            var x = new IntegerRandomInitializer(Int32.MinValue, Int32.MaxValue);
            var y = new IntegerAbsValue();

            for (int i = 0; i < 40; i++)
            {
                int z = 0;
                x.Operate(ref z);
                y.Operate(ref z);

                Assert.True(z >= 0);
            }
        }
    }

    public class DoubleAbsValueTest
    {
        [Fact]
        public void BasicTest()
        {
            var x = new DoubleRandomInitializer(Double.MinValue, Double.MaxValue);
            var y = new DoubleAbsValue();

            for (int i = 0; i < 40; i++)
            {
                double z = 0;
                x.Operate(ref z);
                y.Operate(ref z);

                Assert.True(z >= 0);
            }
        }
    }
}