﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NuMetaheuristics;
using NuMetaheuristics.Genotypes;
using NuMetaheuristics.Operators.Value;
using NuMetaheuristics.Operators.Vector;

using Xunit;

namespace NuMetaheuristics.UnitTests.Vector
{
    public class VectorInitializerTests
    {
        [Fact]
        public void InitializeDoubleVector()
        {
            const double min = 2.0;
            const double max = 4.0;
            var initializer = new DoubleVectorInitializer(new DoubleRandomInitializer(min, max));
            var v = new DoubleVectorGenotype(20);

            initializer.Operate(ref v);
            foreach (double x in v.Vector)
            {
                Assert.True(x >= min && x <= max);
            }
        }

        [Fact]
        public void InitializeDoubleVectorNegativeRange()
        {
            const double min = -10.0;
            const double max = -2.0;
            var initializer = new DoubleVectorInitializer(new DoubleRandomInitializer(min, max));
            var v = new DoubleVectorGenotype(20);

            initializer.Operate(ref v);
            foreach (double x in v.Vector)
            {
                Assert.True(x >= min && x <= max);
            }
        }
    }
}
