﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NuMetaheuristics;
using NuMetaheuristics.Genotypes;
using NuMetaheuristics.Operators.Value;
using NuMetaheuristics.Operators.Vector;

using Xunit;

namespace NuMetaheuristics.UnitTests.Vector
{
    public class VectorSubtractTests
    {
        [Fact]
        public void IntSubtractTest1()
        {
            var x = new int[3] { 1, 2, 3 };
            var y = new int[3] { 0, 0, 0 };

            var Subtracter = new IntegerVectorSubtracter();
            var result = Subtracter.Operate(new IntegerVectorGenotype(x), new IntegerVectorGenotype(y));

            Assert.True(result.Vector.SequenceEqual(x));
        }

        [Fact]
        public void IntSubtractTest2()
        {
            var x = new int[3] { 1, 2, 3 };
            var y = new int[3] { 1, 1, 1 };
            var z = new int[3] { 0, 1, 2 };

            var Subtracter = new IntegerVectorSubtracter();
            var result = Subtracter.Operate(new IntegerVectorGenotype(x), new IntegerVectorGenotype(y));

            Assert.True(result.Vector.SequenceEqual(z));
        }

        [Fact]
        public void IntSubtractTest3()
        {
            var x = new int[3] { 1, 2, 3 };
            var y = new int[3] { -1, -1, -1 };
            var z = new int[3] { 2, 3, 4 };

            var Subtracter = new IntegerVectorSubtracter();
            var result = Subtracter.Operate(new IntegerVectorGenotype(x), new IntegerVectorGenotype(y));
            
            Assert.True(result.Vector.SequenceEqual(z));
        }

        [Fact]
        public void DblSubtractTest1()
        {
            var x = new double[3] { 1.0, 2.0, 3.0 };
            var y = new double[3] { 0.0, 0.0, 0.0 };

            var Subtracter = new DoubleVectorSubtracter();
            var result = Subtracter.Operate(new DoubleVectorGenotype(x), new DoubleVectorGenotype(y));

            Assert.True(result.Vector.SequenceEqual(x));
        }

        [Fact]
        public void DblSubtractTest2()
        {
            var x = new double[3] { 1.0, 2.0, 3.0 };
            var y = new double[3] { 1.0, 1.0, 1.0 };
            var z = new double[3] { 0.0, 1.0, 2.0 };
            
            var Subtracter = new DoubleVectorSubtracter();
            var result = Subtracter.Operate(new DoubleVectorGenotype(x), new DoubleVectorGenotype(y));

            Assert.True(result.Vector.SequenceEqual(z));
        }

        [Fact]
        public void DblSubtractTest3()
        {
            var x = new double[3] { 1.0, 2.0, 3.0 };
            var y = new double[3] { -1.0, -1.0, -1.0 };
            var z = new double[3] { 2.0, 3.0, 4.0 };

            var Subtracter = new DoubleVectorSubtracter();
            var result = Subtracter.Operate(new DoubleVectorGenotype(x), new DoubleVectorGenotype(y));

            Assert.True(result.Vector.SequenceEqual(z));
        }
    }
}
